"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var events_1 = require("events");
var ProcessEnvEventEmitter = /** @class */ (function (_super) {
    __extends(ProcessEnvEventEmitter, _super);
    function ProcessEnvEventEmitter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return ProcessEnvEventEmitter;
}(events_1.EventEmitter));
var processEnv = Object.assign(new ProcessEnvEventEmitter(), process.env);
var skipGetEmit = false;
function emitGet(name, value) {
    var stackTrace = new Error().stack.split('\n');
    var caller = stackTrace[3].match(/\((.*\/.*:.*)\)/)[1];
    var callerIsCoreNode = caller.startsWith('internal');
    /*
      Node modules also use environment variables
      Without this logic an endless loop can be created, for example when using console.log() in a listener
    */
    if (skipGetEmit) {
        return;
    }
    if (callerIsCoreNode) {
        skipGetEmit = true;
    }
    processEnv.emit('get', { name: name, caller: caller, value: value, callerIsCoreNode: callerIsCoreNode });
    skipGetEmit = false;
}
function emitSet(name, previousValue, newValue) {
    var stackTrace = new Error().stack.split('\n');
    var caller = stackTrace[3].match(/\((.*\/.*:.*)\)/)[1];
    processEnv.emit('set', { name: name, caller: caller, previousValue: previousValue, newValue: newValue });
}
var handler = {
    get: function (target, property) {
        if (typeof target[property] === 'string' || target[property] === undefined) {
            emitGet(property, target[property]);
        }
        return Reflect.get(target, property);
    },
    set: function (target, property, value) {
        if (!String(property).startsWith('_events')) {
            emitSet(property, target[property], value);
        }
        return Reflect.set(target, property, value);
    }
};
process.env = new Proxy(processEnv, handler);
